home *** CD-ROM | disk | FTP | other *** search
/ Personal Computer World 2009 February / PCWFEB09.iso / Software / Linux / Kubuntu 8.10 / kubuntu-8.10-desktop-i386.iso / casper / filesystem.squashfs / usr / bin / bashbug < prev    next >
Text File  |  2008-05-12  |  7KB  |  274 lines

  1. #!/bin/sh -
  2. #
  3. # bashbug - create a bug report and mail it to the bug address
  4. #
  5. # The bug address depends on the release status of the shell.  Versions
  6. # with status `devel', `alpha', `beta', or `rc' mail bug reports to
  7. # chet@cwru.edu and, optionally, to bash-testers@cwru.edu.
  8. # Other versions send mail to bug-bash@gnu.org.
  9. #
  10. # Copyright (C) 1996-2004 Free Software Foundation, Inc.
  11. #
  12. # This program is free software; you can redistribute it and/or modify
  13. # it under the terms of the GNU General Public License as published by
  14. # the Free Software Foundation; either version 2, or (at your option)
  15. # any later version.
  16. #
  17. # This program is distributed in the hope that it will be useful,
  18. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  19. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  20. # GNU General Public License for more details.
  21. #
  22. # You should have received a copy of the GNU General Public License
  23. # along with this program; if not, write to the Free Software
  24. # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111 USA.
  25.  
  26. #
  27. # configuration section:
  28. #    these variables are filled in by the make target in Makefile
  29. #
  30. MACHINE="i486"
  31. OS="linux-gnu"
  32. CC="gcc"
  33. CFLAGS=" -DPROGRAM='bash' -DCONF_HOSTTYPE='i486' -DCONF_OSTYPE='linux-gnu' -DCONF_MACHTYPE='i486-pc-linux-gnu' -DCONF_VENDOR='pc' -DLOCALEDIR='/usr/share/locale' -DPACKAGE='bash' -DSHELL -DHAVE_CONFIG_H   -I.  -I../bash -I../bash/include -I../bash/lib   -g -O2 -Wall"
  34. RELEASE="3.2"
  35. PATCHLEVEL="39"
  36. RELSTATUS="release"
  37. MACHTYPE="i486-pc-linux-gnu"
  38.  
  39. PATH=/bin:/usr/bin:/usr/local/bin:$PATH
  40. export PATH
  41.  
  42. # Check if TMPDIR is set, default to /tmp
  43. : ${TMPDIR:=/tmp}
  44.  
  45. #Securely create a temporary directory for the temporary files
  46. TEMPDIR=$TMPDIR/bbug.$$
  47. (umask 077 && mkdir $TEMPDIR) || {
  48.     echo "$0: could not create temporary directory" >&2
  49.     exit 1
  50. }
  51.  
  52. TEMPFILE1=$TEMPDIR/bbug1
  53. TEMPFILE2=$TEMPDIR/bbug2
  54.         
  55. USAGE="Usage: $0 [--help] [--version] [bug-report-email-address]"
  56. VERSTR="GNU bashbug, version ${RELEASE}.${PATCHLEVEL}-${RELSTATUS}"
  57.  
  58. do_help= do_version=
  59.  
  60. while [ $# -gt 0 ]; do
  61.     case "$1" in
  62.     --help)        shift ; do_help=y ;;
  63.     --version)    shift ; do_version=y ;;
  64.     --)        shift ; break ;;
  65.     -*)        echo "bashbug: ${1}: invalid option" >&2
  66.             echo "$USAGE" >& 2
  67.             exit 2 ;;
  68.     *)        break ;;
  69.     esac
  70. done
  71.  
  72. if [ -n "$do_version" ]; then
  73.     echo "${VERSTR}"
  74.     exit 0
  75. fi
  76.  
  77. if [ -n "$do_help" ]; then
  78.     echo "${VERSTR}"
  79.     echo "${USAGE}"
  80.     echo
  81.     cat << HERE_EOF
  82. Bashbug is used to send mail to the Bash maintainers
  83. for when Bash doesn't behave like you'd like, or expect.
  84.  
  85. Bashbug will start up your editor (as defined by the shell's
  86. EDITOR environment variable) with a preformatted bug report
  87. template for you to fill in. The report will be mailed to the
  88. bash maintainers by default. See the manual for details.
  89.  
  90. If you invoke bashbug by accident, just quit your editor without
  91. saving any changes to the template, and no bug report will be sent.
  92. HERE_EOF
  93.     exit 0
  94. fi
  95.  
  96. # Figure out how to echo a string without a trailing newline
  97. N=`echo 'hi there\c'`
  98. case "$N" in
  99. *c)    n=-n c= ;;
  100. *)    n= c='\c' ;;
  101. esac
  102.  
  103. BASHTESTERS="bash-testers@cwru.edu"
  104.  
  105. case "$RELSTATUS" in
  106. alpha*|beta*|devel*|rc*)    BUGBASH=chet@cwru.edu ;;
  107. *)                BUGBASH=bug-bash@gnu.org ;;
  108. esac
  109.  
  110. case "$RELSTATUS" in
  111. alpha*|beta*|devel*|rc*)
  112.         echo "$0: This is a testing release.  Would you like your bug report"
  113.         echo "$0: to be sent to the bash-testers mailing list?"
  114.         echo $n "$0: Send to bash-testers? $c"
  115.         read ans
  116.         case "$ans" in
  117.         y*|Y*)    BUGBASH="${BUGBASH},${BASHTESTERS}" ;;
  118.         esac ;;
  119. esac
  120.  
  121. BUGBASH="${BUGBASH},bash@packages.debian.org"
  122. BUGADDR="${1-$BUGBASH}"
  123.  
  124. if [ -z "$DEFEDITOR" ] && [ -z "$EDITOR" ]; then
  125.     if [ -x /usr/bin/editor ]; then
  126.         DEFEDITOR=editor
  127.     elif [ -x /usr/local/bin/ce ]; then
  128.         DEFEDITOR=ce
  129.     elif [ -x /usr/local/bin/emacs ]; then
  130.         DEFEDITOR=emacs
  131.     elif [ -x /usr/contrib/bin/emacs ]; then
  132.         DEFEDITOR=emacs
  133.     elif [ -x /usr/bin/emacs ]; then
  134.         DEFEDITOR=emacs
  135.     elif [ -x /usr/bin/xemacs ]; then
  136.         DEFEDITOR=xemacs
  137.     elif [ -x /usr/contrib/bin/jove ]; then
  138.         DEFEDITOR=jove
  139.     elif [ -x /usr/local/bin/jove ]; then
  140.         DEFEDITOR=jove
  141.     elif [ -x /usr/bin/vi ]; then
  142.         DEFEDITOR=vi
  143.     else
  144.         echo "$0: No default editor found: attempting to use vi" >&2
  145.         DEFEDITOR=vi
  146.     fi
  147. fi
  148.  
  149.  
  150. : ${EDITOR=$DEFEDITOR}
  151.  
  152. : ${USER=${LOGNAME-`whoami`}}
  153.  
  154. trap 'rm -rf "$TEMPDIR"; exit 1' 1 2 3 13 15
  155. trap 'rm -rf "$TEMPDIR"' 0
  156.  
  157. UN=
  158. if (uname) >/dev/null 2>&1; then
  159.     UN=`uname -a`
  160. fi
  161.  
  162. if [ -f /usr/lib/sendmail ] ; then
  163.     RMAIL="/usr/lib/sendmail"
  164.     SMARGS="-i -t"
  165. elif [ -f /usr/sbin/sendmail ] ; then
  166.     RMAIL="/usr/sbin/sendmail"
  167.     SMARGS="-i -t"
  168. else
  169.     RMAIL=rmail
  170.     SMARGS="$BUGADDR"
  171. fi
  172.  
  173. INITIAL_SUBJECT='[50 character or so descriptive subject here (for reference)]'
  174.  
  175. cat > "$TEMPFILE1" <<EOF
  176. From: ${USER}
  177. To: ${BUGADDR}
  178. Subject: ${INITIAL_SUBJECT}
  179.  
  180. Configuration Information [Automatically generated, do not change]:
  181. Machine: $MACHINE
  182. OS: $OS
  183. Compiler: $CC
  184. Compilation CFLAGS: $CFLAGS
  185. uname output: $UN
  186. Machine Type: $MACHTYPE
  187.  
  188. Bash Version: $RELEASE
  189. Patch Level: $PATCHLEVEL
  190. Release Status: $RELSTATUS
  191.  
  192. Description:
  193.     [Detailed description of the problem, suggestion, or complaint.]
  194.  
  195. Repeat-By:
  196.     [Describe the sequence of events that causes the problem
  197.     to occur.]
  198.  
  199. Fix:
  200.     [Description of how to fix the problem.  If you don't know a
  201.     fix for the problem, don't include this section.]
  202. EOF
  203.  
  204. cp "$TEMPFILE1" "$TEMPFILE2"
  205. chmod u+w "$TEMPFILE1"
  206.  
  207. trap '' 2        # ignore interrupts while in editor
  208.  
  209. edstat=1
  210. while [ $edstat -ne 0 ]; do
  211.     $EDITOR "$TEMPFILE1"
  212.     edstat=$?
  213.  
  214.     if [ $edstat -ne 0 ]; then
  215.         echo "$0: editor \`$EDITOR' exited with nonzero status."
  216.         echo "$0: Perhaps it was interrupted."
  217.         echo "$0: Type \`y' to give up, and lose your bug report;"
  218.         echo "$0: type \`n' to re-enter the editor."
  219.         echo $n "$0: Do you want to give up? $c"
  220.  
  221.         read ans
  222.         case "$ans" in
  223.         [Yy]*) exit 1 ;;
  224.         esac
  225.  
  226.         continue
  227.     fi
  228.  
  229.     # find the subject from the temp file and see if it's been changed
  230.     CURR_SUB=`grep '^Subject: ' "$TEMPFILE1" | sed 's|^Subject:[     ]*||' | sed 1q`
  231.  
  232.     case "$CURR_SUB" in
  233.     "${INITIAL_SUBJECT}")
  234.         echo
  235.         echo "$0: You have not changed the subject from the default."
  236.         echo "$0: Please use a more descriptive subject header."
  237.         echo "$0: Type \`y' to give up, and lose your bug report;"
  238.         echo "$0: type \`n' to re-enter the editor."
  239.         echo $n "$0: Do you want to give up? $c"
  240.  
  241.         read ans
  242.         case "$ans" in
  243.         [Yy]*) exit 1 ;;
  244.         esac
  245.  
  246.         echo "$0:  The editor will be restarted in five seconds."
  247.         sleep 5
  248.         edstat=1
  249.         ;;
  250.     esac
  251.  
  252. done
  253.  
  254. trap 'rm -rf "$TEMPDIR"; exit 1' 2    # restore trap on SIGINT
  255.  
  256. if cmp -s "$TEMPFILE1" "$TEMPFILE2"
  257. then
  258.     echo "File not changed, no bug report submitted."
  259.     exit
  260. fi
  261.  
  262. echo $n "Send bug report? [y/n] $c"
  263. read ans
  264. case "$ans" in
  265. [Nn]*)    exit 0 ;;
  266. esac
  267.  
  268. ${RMAIL} $SMARGS < "$TEMPFILE1" || {
  269.     cat "$TEMPFILE1" >> $HOME/dead.bashbug
  270.     echo "$0: mail failed: report saved in $HOME/dead.bashbug" >&2
  271. }
  272.  
  273. exit 0
  274.